<template>
  <button class="app-button" :class="[classes ? classes : '', theme ? `app-button--${theme}` : '', isSmall ? 'app-button--is-small' : '', isLink ? 'app-button--is-link' : '']" :disabled="isDisabled" @click="$emit('button-click')">
    <slot></slot>
  </button>
</template>

<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'AppButton',

  props: {
    classes: {
      type: String,
      default: ''
    },
    isDisabled: {
      default: false,
      type: Boolean
    },
    isLink: {
      default: false,
      type: Boolean
    },
    isSmall: {
      default: false,
      type: Boolean
    },
    theme: {
      type: String,
      default: ''
    }
  }
});
</script>

<style lang="scss" scoped>
.app-button {
  min-width: 14rem;
  padding: 1rem;
  background: var(--color-primary);
  color: var(--color-light);
  font-size: 1.2rem;
  cursor: pointer;
  border-radius: 2rem;
  transition-property: color, filter, transform;
  transition-duration: .2s;
  transition-timing-function: linear;

  &:hover {
    filter: brightness(130%);
  }

  &:active {
    transform: scale(.98);
  }

  &:disabled {
    pointer-events: none;
    opacity: .5;
  }

  &--is-small {
    min-width: auto;
    padding: .5rem 1rem;
    font-size: 1rem;
  }

  &--is-link {
    min-width: auto;
    padding: .5rem;
    background: transparent;
    color: var(--color-primary);

    &:hover {
      color: var(--color-accent);
    }

    &:active {
      transform: scale(1);
    }
  }

  &--lanister {
    background: var(--color-lanister);
  }

  &--starks {
    background: var(--color-starks);
  }
}

</style>
